// subPackage/page/pages/subPage/subPage.js
const app = getApp()
const wxService = require('../../../../utils/wxService')
const utils = require('../../../../utils/util')
const envInfo = require('../../../../config/index').envInfo
let renderPage = null // 渲染页面数据对象(安全渲染)
let handlerDataOnPage = null
let config = require('../../../../configScreen/configScreen');
import { Integer } from '../../../../utils/integerDigitalConvertion'

const logger = utils.logger

wxService.page({
  /**
   * 页面的初始数据
   */
  data: {
    pages: [],
    paddingBottom :'0',
    render: null, // 渲染页面数据对象(安全渲染)
    renderPageOver: false, // 渲染页面结束
    integralNum: 0,
    couponNum: 0,
    valueCardNum: 0,
    // isAllScreen: fullSucreen.isAllScreen
    isAllScreen: config.isAllScreen,
    token: '',
    isAuthorization: false,
    pageId: 3,
    baseUserInfo: null,
    // cardMember: null,
    pageBackgroundColor: 0,
    guidePageModalShow: false,
    currHomePageId: '',
    skuVOList:[],
    //显示广告
    pageInfo : null,
    categoryTabFixed : false,
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    this.setData(
      {
        pages: [],
        groupLoadState: 'complete', // 活动分组加载标志
        homeApiLoading: true,
        render: null, // 渲染页面数据对象(安全渲染)
        isLastPage: false, // 页面段落加载完成
        renderPageOver: false, // 渲染页面结束
        // isAuthorization: true,
        outoHeigth: 500,
      },
      () => {
        // this.loadMore()
      }
    )
    handlerDataOnPage = new utils.HandlerDataOnPage()
    renderPage = require('../../../../utils/renderPage').getRenderPage()
    handlerDataOnPage.init(this, 'pages')
    // 判断 
    if(options.pageId){
      this.data.pageId = options.pageId;
      this.setData({
        pageId: this.data.pageId
      });

      this.initPage(this.data.pageId);
      setTimeout(() => {
        this.getElementTop();
        // categoryTab
      },1000);
    }
    else{
      let pageId = shareId;
      if (options['scene']) {
        let idParam = decodeURIComponent(options['scene']).split('&')[0];
        // let hasPageId = idParam ? (idParam.indexOf('pageId') > -1 ? true : false) : false;
        let shareId = idParam && idParam.split('=')[1] || 0;
        pageId = shareId;
      }

      this.data.pageId = pageId;
      this.setData({
        pageId: this.data.pageId
      });

      this.initPage(this.data.pageId);

      
    }
    //判断是否带m 触点
    let memberId = options.memberId;
    if (memberId) {
      let tentacleInfo = {
        content: '小程序动态页面',
        title: '小程序动态页面',
        tentacleId: memberId,
        contentType: app.globalData.contants.SHARE_TYPE.HOME,
        type: 3// 1:门店,2:员工(暂时不做),3:会员,4:第三方外部渠道,5:智能营销
      };

      this.generatePointObject(tentacleInfo);
    }
  },

  // 页面滚动到底部
  onReachBottom(){
    if(this.categoryTabComponent){
      this.categoryTabComponent.getTagProducts('scrollBottom');
    }
  },

  //页面滚动
  onPageScroll(e){
    if(!this.scrollTop){
      return ;
    }

    let scrollTop = e.scrollTop;
    this.throttle(scoTop => {
      if(scoTop > this.scrollTop){
        this.data.categoryTabFixed = true;
      }
      else{
        this.data.categoryTabFixed = false;
      }
      this.setData({
        categoryTabFixed : this.data.categoryTabFixed
      });
    },null,0,scrollTop);
  },

  //节流器
  throttle(fn, context, delay, text){
    clearTimeout(fn.timeoutId)
    fn.timeoutId = setTimeout(function () {
      fn.call(context, text)
    }, delay)
  },

  //获取元素到顶部的里
  getElementTop(){
    wx.createSelectorQuery().select('.categoryTab').boundingClientRect(res => {
      if(res){
        this.scrollTop = res.top;
        this.categoryTabComponent = this.selectComponent('#categoryTab');
      }
    }).exec();
  },

  //子组件更新成功
  loadProductComplete(e){
    if(e.detail == 'tabChange'){
      let filterLevel = this.data.pages.filter(item => item.type == 11);
      if(filterLevel.length != 0){
        let levelIndex = filterLevel[0].levelIndex;
        this.data.pages.filter(item => item.levelIndex > levelIndex).forEach(item => {
          item.pShow = false;
        });

        this.setData({
          pages : this.data.pages
        });
      }
    }
    else{
      this.data.pages.forEach(item => {
        item.pShow = true;
      });
      this.setData({
        pages : this.data.pages
      })
    }
  },

  /** 
   * 监听子组件事件
   * */
  updatePage(ev) {
    const { pageId } = ev.detail
    // this.setData({
    //   pages: [],
    //   pageId
    // },()=>{
    //   this.initPage(pageId)
    // })
    wxService.router(`/subPackage/page/pages/subPage/subPage`).search({ pageId })
  },
  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    const { memberId, member } = wx.getStorageSync('_baseUserInfo')
   
    // 取会员卡号
    const baseUserInfo = wx.getStorageSync('_baseUserInfo')
    const cardMember = wx.getStorageSync('_cardMember')
    // 登录接口返回err
    const reLoginErrFlag = wx.getStorageSync('reLoginErr')
    if (baseUserInfo && !reLoginErrFlag) {
      this.setData({
        token: wx.getStorageSync('token'),
        baseUserInfo,
        cardMember,
        isAuthorization: false
      }, () => {
        // 积分数量
        this.getMemberPointInfo()
        //获取我的超值卡数
        this.getMyValueCardNum();
        // 优惠券数量
        this.getMemberCouponInfo()
      })
    }
    else if (!baseUserInfo && reLoginErrFlag) {
      this.setData({
        isAuthorization: true
      })
    }
    else {
      this.setData({
        isAuthorization: true
      })
    }
    // if (baseUserInfo){
    //   this.setData({
    //     token: wx.getStorageSync('token'),
    //     baseUserInfo,
    //     // cardMember,
    //     isAuthorization: false
    //   })

    //   // 积分数量
    //   this.getMemberPointInfo()
    //   // 优惠券数量
    //   this.getMemberCouponInfo()
    // } else {
    //   this.setData({
    //     isAuthorization: true
    //   })
    // }
    // 获取plus购买信息
    // this.getPlusPurchase()
    // 获取手机信息
    wxService.getSystemInfo().then(res => {
      this.setData({
        outoHeigth: res.windowHeight
      })
    })
    // 设置当前选中 Tab 
    if (typeof this.getTabBar === 'function' &&
      this.getTabBar()) {
      this.getTabBar().setData({
        selected: 0
      })
    }
  },
  // 查询积分信息
  getMemberPointInfo() {
    wx.showLoading({
      title: '加载中'
    })
    wxService.get(`/member/memberPoint/getMyPointInfo`).then(res => {
      if (res) {
        const { result, data } = res.data
        if (result == 0) {
          wx.hideLoading()
          this.setData({
            integralNum: data && data.point || 0
          })
        }
      }
    })
  },
  //查询超值卡数量
  getMyValueCardNum() {
    const { memberId } = wx.getStorageSync('_baseUserInfo')
    if (memberId) {
      wxService.post(`/merchant/superValueCard/miniProgram/valiCard/getQuantity?memberId=${memberId}`).then(res => {
        if (res) {
          let data = res.data.data ? res.data.data : 0;
          this.data.valueCardNum = data;
          this.setData({
            valueCardNum: this.data.valueCardNum
          });
        }
      });
    }
  },
  // 查询优惠券数量
  getMemberCouponInfo() {
    wx.showLoading({
      title: '加载中'
    })
    wxService.post(`/coupon/coupon/memberCouponCount`).then(res => {
      if (res) {
        const { result, data } = res && res.data
        if (result == 0) {
          wx.hideLoading()
          this.setData({
            couponNum: data && data[1] || 0
          })
        }
      }
    })
  },
  // page 信息
  initPage(pageId) {
    this.setData({
      products: []
    })
    wx.showLoading({
      title: '加载中'
    })
    wxService.post(`/merchant/modelPage/getDetailById?pageId=${pageId}&brandId=${app.globalData.brandId}`).then(res => {
    // wxService.post(`/merchant/modelPage/mainSetting/mall?brandId=${app.globalData.brandId}`).then(res => {
      if (!res) return false
      const { result, data } = res.data;
      this.data.pageBackgroundColor =  data.page.backgroundColor ? data.page.backgroundColor : 0;
      if (result == 0) {
        this.setData({
          pageBackgroundColor: this.data.pageBackgroundColor 
        });
        // 动态设置title
        wx.setNavigationBarTitle({
          title: data.page.title
        });

        this.data.pageInfo = data.page;
        // 首页 pageId
        // data.page.pageId
        this.setData({
          currHomePageId: data.page.pageId,
          pageInfo : this.data.pageInfo
        });
        
        // 段落
        const products = data.paragraphs
        const filterResult = products.map((res, index) => {
          return {
            ...res, index
          }
        }).filter(item => {
          // wx.hideLoading()
        })
        
        this.handleParaphe(products);

        const render = renderPage.initPaging(filterResult).initRenderData(products)
        this.data.render = render
        const renderData = render.next()
        this.data.renderPageOver = renderData.done
        this.renderPageFunc({ products: renderData.value })

        //是否有tabbar 或 plus
        let tabbar = products.filter(item => item.type == 5);
        let plus = products.filter(item => item.type == 9);

        if (plus.length != 0) {
          this.setData({
            paddingBottom: '96rpx',
            outoHeigth : 0,
          })
        }
        else if (tabbar.length != 0) {
          this.setData({
            paddingBottom: '130rpx',
            outoHeigth: this.data.outoHeigth - 73,
          })
        }
        else {
          this.setData({
            paddingBottom: '0rpx'
          })
        }
      }
    }).finally(() => {
      wx.hideLoading();
    })
  },
  //处理段落隐藏和显示
  handleParaphe(products){
    //把段落增加一个index
    products.forEach((item,index) => {
      item.levelIndex = index;
      item.pShow = true;//默认都显示
    });
    
    //查找一下 看看有没有类型是11的
    let filterCategoryTab = products.filter(item => item.type == 11);
    //如果有的话 则把其以下的都隐藏 (目前仅支持一个)
    if(filterCategoryTab.length != 0){
      let levelIndex = filterCategoryTab[0].levelIndex;
      products.filter(item => item.levelIndex > levelIndex).forEach(c => {
        c.pShow = false;
      });
    }
  },
  /**
	 * 渲染数据(合并之前的数据)
	 * @param products 数组数据
	 * @param isLastPage
	 * @param now
	 */
  renderPageFunc({ products }) {
    // 9 plus(9/5-权重高)
    let newProducts = [...products]
    let typeArr = []
    newProducts.map(item => typeArr.push(item.type))
    if (typeArr.includes(9) && typeArr.includes(5)) {
      newProducts.forEach((item, index) => {
        if (item.type == 5) { newProducts.splice(index, 1) }
      })
    }

    // let productData = handlerDataOnPage.handlerArray(products)
    let productData = handlerDataOnPage.handlerArray(newProducts)
    logger.log('productData.keysNum', productData.keysNum(), productData)

    this.setData({
      ...productData
    }, () => {
      wx.hideLoading()
    })
  },
 
  // 获取plus购买信息
  // getPlusPurchase() {
  //   wxService.get(`/sale/premium/query`).then(res => {
  //     if(!res) return false
  //     const { result, data } = res.data
  //     if (result == 0) {
  //       this.setData({
  //         skuVOList: data
  //       })
  //     }
  //   }).finally(() => {
  //   })
  // },
  /**
  * 用户点击右上角分享
  */
  onShareAppMessage: function (res) {
   
  }
})